{afterEach, beforeEach, describe, it} = global
{expect}      = require 'chai'
sinon         = require 'sinon'

_             = require 'lodash'
enableDestroy = require 'server-destroy'
shmock        = require 'shmock'
SocketIO      = require 'socket.io'


Inquisitor    = require '..'

describe 'clearErrors', ->
  beforeEach ->

    meshbluConfig =
      uuid: 'user-uuid'
      token: 'user-token'
      hostname: 'localhost'
      port: 0xd00d
      protocol: 'http'

    uuid = 'inquisitor-uuid'

    @userAuth = new Buffer('user-uuid:user-token').toString 'base64'
    @sut = new Inquisitor {meshbluConfig, uuid}

  it 'should exist', ->
    expect(@sut).to.exist

  describe '->clearErrors', ->
    beforeEach 'meshblu', ->
      @meshblu = shmock 0xd00d
      enableDestroy(@meshblu)

    afterEach (done) ->
      @meshblu.destroy done

    beforeEach ->
      @clearErrorsHandler = @meshblu
        .put "/v2/devices/the-device-uuid"
        .set 'Authorization', "Basic #{@userAuth}"
        .send $unset: errors: true
        .reply 200

    beforeEach (done) ->
      @sut.clearErrors 'the-device-uuid',  (@error) => done()
      return null

    it 'should clear the errors property on the status device', ->
      @clearErrorsHandler.done()
